// Beltrani Saele 0000311983


import java.io.BufferedReader;
import java.io.EOFException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.*;
import java.util.StringTokenizer;

public class Client {
    /*
     * USO: lanciare il client per avviare l'interazione con l'utente
     */

    public static void main(String[] args) {
        /*
         * protocollo:
         * Chiedo la lista dei file con "CL"
         * ricevo n stringhe quanti sono i file di tipo "FILE":FILE
         * Chiede l'endpoint di un server con "CL":FILE
         * ricevo IP:PORT del MulticastServer se c'è, sennò con "NOTFOUND"
         */
        DatagramSocket discoverySocket = null;
        InetAddress addr = null;
        int port = -1;
        DatagramPacket pack = null;
        MulticastSocket sock = null;
        byte[] buf = new byte[256];
        String toSend;
        String received;
        String requested;

        //chiedo all'utente il DiscoveryServer al quale connettermi
        try {
            Boolean creataSocket = false;
            while(!creataSocket){
                System.out.println("A quale Discovery connettersi? IP:PORTA");
                BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
                requested = br.readLine();
                StringTokenizer str = new StringTokenizer(requested,":");
                if(str.countTokens()!=2){
                    System.out.println("Il nome del discovery deve essere nella forma IP:PORTA");
                    continue;
                } //if
                try{
                    addr = InetAddress.getByName(str.nextToken());
                    port = Integer.parseInt(str.nextToken());
                    if(port < 1 || port > 65535){
                        System.out.println("Porta non valida");
                        continue;
                    } //if
                } catch(NumberFormatException nfex){
                    System.out.println("Porta non valida");
                    continue;
                } catch(UnknownHostException uhex){
                    System.out.println("Indirizzo non valido");
                    continue;
                } //try-catch
                creataSocket = true;
            } //while
            pack = new DatagramPacket(buf, buf.length, addr, port);
            discoverySocket = new DatagramSocket();
            discoverySocket.setSoTimeout(10000);
            
            //richiesta lista file al discovery
            toSend = "CL";
            pack = Utility.insertStringInPacket(pack, toSend);
            discoverySocket.send(pack);
            System.out.println("Ricezione elenco file...");
            Boolean primaRicezione = true;
            do{
                buf = new byte[256];
                pack.setData(buf);
                discoverySocket.receive(pack);
                received = Utility.getStringFromPacket(pack);
                if(primaRicezione && received.isEmpty()){
                    throw new EOFException();
                } //if
                System.out.println(received);
                primaRicezione = false;
            } while((!received.isEmpty())); //do-while

            //interazione con l'utente per la scelta del file
            Boolean fileEsistente = false;
            while(!fileEsistente){
                System.out.println("Da quale file leggere le stringhe?");
                BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
                requested = br.readLine();
                toSend = "CL:"+requested;
                pack = Utility.insertStringInPacket(pack, toSend);
                discoverySocket.send(pack);
                buf = new byte[256];
                pack.setData(buf);
                discoverySocket.receive(pack);
                received = Utility.getStringFromPacket(pack);
                if(received.equals("NOTFOUND")){
                    System.out.println("File non trovato");
                    continue;
                } else break;
            } //while
            discoverySocket.close();
            StringTokenizer str = new StringTokenizer(received, ":");
            addr = InetAddress.getByName(str.nextToken());
            port = Integer.parseInt(str.nextToken());

            //connessione al multicast e stampa a schermo delle linee ricevute
            sock = new MulticastSocket(port);
            sock.joinGroup(addr);
            sock.setSoTimeout(10000);
            System.out.println("Inizio ricezione");
            while(true){
                buf = new byte[256];
                pack.setData(buf);
                sock.receive(pack);
                received = Utility.getStringFromPacket(pack);
                System.out.println(received);
            } //while
        } catch (NumberFormatException nfex) {
            System.out.println("Errore nella lettura dell'indirizzo");
            System.exit(1);
        } catch (SocketTimeoutException stex){
            System.out.println("Inattività socket");
            sock.close();
            System.exit(1);
        } catch (SocketException sckex) {
            System.out.println("Errore nella lettura dell'indirizzo");
            System.exit(1);
        } catch (UnknownHostException uhex) {
            System.out.println("Errore nella creazione del pacchetto");
            System.exit(1);
        } catch (EOFException eofex){
            System.out.println("Nessun file sul server, termino");
            discoverySocket.close();
            System.exit(1);
        } catch (IOException ioex) {
            System.out.println("Errore di comunicazione");
            discoverySocket.close();
            sock.close();
            System.exit(1);
        } //try-catch
    } //main
} //class

