// Beltrani Saele 0000311983

import java.io.IOException;
import java.net.*;
import java.util.StringTokenizer;
import java.util.Vector;

public class DiscoveryRun extends Thread{
    private int PORTA;
    private DatagramSocket sock = null;
    private Boolean ferma = false;
    
    public DiscoveryRun(int port){
        PORTA = port;
    } //DiscoveryRun

    @Override
    public void run(){
        String received;
        String response;
        String identifier;
        String requestedFile;
        InetAddress MCAddr = null;
        int MCPort = -1;
        String MCFile;
        StringTokenizer str = null;
        boolean accept = true;

        // strutture per mantenimento corrispondenza endpoint-file
        Vector serverPort = new Vector();
        Vector serverAddr = new Vector();
        Vector serverFile = new Vector();

        // inizializzazione DiscoveryServer
        DatagramPacket pack = null;
        byte[] buf = new byte[256];
        try {
            sock = new DatagramSocket(PORTA);
            pack = new DatagramPacket(buf, buf.length);
            //System.out.println("Discovery in ascolto su: "+PORTA);
        } catch (SocketException ex) {
            System.out.println("DiscoveryServer: impossibile aprire socket");
            if(sock!= null) sock.close();
            System.exit(1);
        } //try-catch
        while (true) {
            try {
                buf = new byte[256];
                pack.setData(buf);
                try{
                    sock.receive(pack);
                } catch(IOException ex){
                    if(ferma) System.exit(0); else throw ex;
                } //try-catch

                received = Utility.getStringFromPacket(pack);
                str = new StringTokenizer(received, ":");
                identifier = str.nextToken();
                if (identifier.equals("MC")) {

                    //richiesta di un Multicastserver
                    MCAddr = InetAddress.getByName(str.nextToken());
                    MCPort = Integer.parseInt(str.nextToken());
                    MCFile = str.nextToken();

                    // verifico che non ci siano altri server con stesso endpoint o file
                    for (int i = 0; i < serverFile.size(); i++) {
                        if (((String) serverFile.elementAt(i)).equals(MCFile)) {
                            accept = false;
                        }
                        if (((InetAddress) serverAddr.elementAt(i)).equals(MCAddr) &&
                                ((Integer) serverPort.elementAt(i)).equals(MCPort)) {
                            accept = false;
                        }
                    } //for

                    //rispondo al Multicast Server e aggiorno la struttura
                    if (accept) {
                        response = "si";
                        serverFile.addElement(MCFile);
                        serverAddr.addElement(MCAddr);
                        serverPort.addElement(MCPort);
                        //System.out.println("Si è aggiunto "+MCAddr.getHostAddress()+":"+MCPort+" col file "+MCFile);
                    } else {
                        response = "no";
                    } //if-else
                    pack = Utility.insertStringInPacket(pack, response);
                    sock.send(pack);
                    accept = true;
                } else if(identifier.equals("MCOFF")){
                    //Elimino il MulticastServer dalle strutture dati
                    MCAddr = InetAddress.getByName(str.nextToken());
                    MCPort = Integer.parseInt(str.nextToken());
                    for (int i = 0; i < serverFile.size(); i++) {
                        if(((InetAddress)serverAddr.elementAt(i)).equals(MCAddr)){
                            if(((Integer)serverPort.elementAt(i)).equals(MCPort)){
                                serverAddr.removeElementAt(i);
                                serverFile.removeElementAt(i);
                                serverPort.removeElementAt(i);
                                //System.out.println("Se n'è andato "+MCAddr.getHostAddress()+":"+MCPort);
                            } //if address&port equal
                        } // if address equal
                    } //for
                } else if (identifier.equals("CL")) {

                    //richiesta di un cliente
                    if (str.hasMoreTokens()) {

                        // chiede un file specifico
                        requestedFile = str.nextToken();
                        response = "NOTFOUND";
                        for (int i = 0; i < serverFile.size(); i++) {
                            if (((String) serverFile.elementAt(i)).equals(requestedFile)) {
                                response = ((InetAddress) serverAddr.elementAt(i)).getHostAddress() +":"+ ((Integer) serverPort.elementAt(i));
                                break;
                            } //if
                        } //for
                        pack = Utility.insertStringInPacket(pack, response);
                        sock.send(pack);
                    } else {

                        // chiede la lista file
                        for (int i = 0; i < serverFile.size(); i++) {
                            response = ((String) serverFile.elementAt(i));
                            pack = Utility.insertStringInPacket(pack, response);
                            sock.send(pack);
                        } //for
                        response = "";
                        pack = Utility.insertStringInPacket(pack, response);
                        sock.send(pack);
                    } //if-else
                } else {
                    System.out.println("Errore di protocollo nel pacchetto ricevuto");
                    break;
                } //if-else
            } catch (IOException ioex) {
                System.out.println("Errore IO: "+ioex.getLocalizedMessage());
                ioex.printStackTrace();
                break;
            } catch (NumberFormatException nfex) {
                System.out.println("Errore conversione numero: "+nfex.getLocalizedMessage());
                break;
            } //try-catch
        } //while
        if(sock != null) sock.close();
        System.exit(1);
    } //run

    public void stopListen(){
        ferma = true;
        if (sock != null) sock.close();
        System.exit(0);
    }

} //class
