// Beltrani Saele 0000311983


import java.io.*;

public class DiscoveryServer {
    /*
     * USO: lanciare il server per attivarlo e metterlo in attesa
     */

    public static void main(String[] args) {
        int PORT = -1;

        // attendo richieste di clienti o server multicast
        /*
         * protocollo:
         * MulticastServer chiede connessione con "MC":IP:PORT:FILE
         * rispondo al server con "si" o "no" se accetto o meno la connessione
         * MulticastServer chiede disconnessione con "MCOFF":IP:PORT
         * Client chiede la lista dei file con "CL"
         * rispondo con n stringhe quanti sono i server (e i file) poi chiudo con una stringa vuota
         * Client chiede l'endpoint di un server con "CL":FILE
         * rispondo con IP:PORT del MulticastServer se c'è, sennò con "NOTFOUND"
         */

        boolean portaLetta = false;
        System.out.println("Su che porta vuoi connettere il server?");
        while(!portaLetta){
             BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
             try{
                 PORT = Integer.parseInt(br.readLine());
                 if(PORT < 0 || PORT > 65535) throw new NumberFormatException();
             } catch(IOException ex){
                 System.out.println("Errore di lettura, riprova");
                 continue;
             } catch(NumberFormatException nex){
                 System.out.println("La porta deve essere un numero tra 0 e 65535");
                 continue;
             } //try-catch
             portaLetta = true;
        } //while

        System.out.println("\nRunning... digita \"stop\" per chiudere");
        DiscoveryRun r = new DiscoveryRun(PORT);
        r.start();
        System.out.println("Discovery in ascolto su: "+PORT);
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        while(true){
            try{
                if(br.readLine().equals("stop")) break;
            } catch(IOException ex){
                System.out.println("Errore nella lettura del comando");
                continue;
            } //try-catch
        } //while
        r.stopListen();
        System.out.println("Termino");
    } //main
} //class

