// Beltrani Saele 0000311983

import java.io.File;
import java.io.IOException;
import java.net.*;
import java.util.logging.Level;
import java.util.logging.Logger;

public class MulticastMessageSender extends Thread {
    /*
     * un'istanza di questa classe si occupa dell'effettivo invio dei messaggi e
     * il multicast server vero e proprio funge da interfaccia con l'utente
     */

    private File f;
    private DatagramPacket pack;
    private MulticastSocket multicastSock;
    private boolean send=true;

    public MulticastMessageSender(File f, DatagramPacket pack, MulticastSocket multicastSock) {
        this.f = f;
        this.pack = pack;
        this.multicastSock = multicastSock;
    }

    @Override
    public void run() {
        int numeroLinea = 1;
        while (send) {
            String linea = Utility.leggiLineaDaFile(numeroLinea, f.getPath());
            if (linea.equals("")) {
                numeroLinea = 1;
                continue;
            } else {
                numeroLinea++;
            } //if-else
            pack = Utility.insertStringInPacket(pack, linea);
            try {
                multicastSock.send(pack);
                Thread.sleep(3000);
            } catch (IOException ex) {

            } catch (InterruptedException iex){

            }
        } //while
    } //run

    protected void stopSending(){
        send = false;
    } //stopSending

} //class
