


import java.io.*;
import java.net.*;

// Beltrani Saele 0000311983

public class Utility {
    public static String leggiLineaDaFile(int numeroLinea, String nomeFile){
            String lineaLetta="";
            int linea = numeroLinea;
            try{
                BufferedReader br = new BufferedReader(new FileReader(new File(nomeFile)));
                for(int i=0;i<linea;i++){
                    lineaLetta = br.readLine();
                    if(lineaLetta == null){
                        lineaLetta = "";
                        break;
                    }
                } //for
                br.close();
            } catch(FileNotFoundException ex){
                System.out.println("File non trovato: "+ex.getLocalizedMessage());
                return "";
            } catch(IOException e){
                System.out.println("Errore nella lettura del file: "+e.getLocalizedMessage());
                return "";
            } //try-catch
            return lineaLetta;
    } //leggiLineaDaFile

    public static String getStringFromPacket(DatagramPacket p){
        String msg = "";
        ByteArrayInputStream bi = new ByteArrayInputStream(p.getData());
        DataInputStream di = new DataInputStream(bi);
        try {
            msg = di.readUTF();
        } catch (IOException ex) {
            System.out.println("Errore nell'estrazione della stringa dal pacchetto: "+ex.getLocalizedMessage());
            return "";
        } //try-catch
        return msg;
    } //getStringFromPacket

    public static DatagramPacket insertStringInPacket(DatagramPacket p, String msg){
        try {
            DatagramPacket pack = p;
            byte[] buf = new byte[256];
            ByteArrayOutputStream bo = new ByteArrayOutputStream();
            DataOutputStream dOut = new DataOutputStream(bo);
            dOut.writeUTF(msg);
            buf = bo.toByteArray();
            pack.setData(buf);
            return pack;
        } catch (IOException ex) {
            System.out.println("Impossibile inserire il messaggio nel pacchetto: "+ex.getLocalizedMessage());
            return null;
        } //try-catch
    } //insertStringInPacket
} //class
